package br.ime.usp.pictware.util;

import java.util.List;

import com.thoughtworks.xstream.XStream;

import br.usp.ime.pictware.business.assinante.bo.Assinante;

public class AssinanteXMLConverter {

	public static String assinantesToXML(List<Assinante> listaAssinantes){
		XStream xStream = new XStream();
		xStream.alias("assinantes", List.class);
		xStream.alias("assinante", Assinante.class);
		xStream.omitField(Assinante.class, "senha");
		xStream.omitField(Assinante.class, "listaAlbuns");
		xStream.omitField(Assinante.class, "listaGrupoAcesso");
		String xml = xStream.toXML(listaAssinantes);
		return xml;
	}
	
	public static Assinante assinanteFromXML(String xml){
		XStream xStream = new XStream();
		xStream.aliasType("assinante", Assinante.class);
		Assinante assinante = (Assinante)xStream.fromXML(xml);
		return assinante;
	}
	
}
