package br.usp.ime.pictware.application.album.service;

import br.usp.ime.pictware.business.album.bo.Album;
import br.usp.ime.pictware.business.album.bo.Foto;
import br.usp.ime.pictware.business.album.dao.AlbumDAO;
import br.usp.ime.pictware.business.assinante.bo.Assinante;

public class ManterAlbumService {

	public ManterAlbumService(){
		
	}
	
	private AlbumDAO albumDAO;
	
	public AlbumDAO getAlbumDAO() {
		return albumDAO;
	}

	public void setAlbumDAO(AlbumDAO albumDAO) {
		this.albumDAO = albumDAO;
	}

	public void incluirAlbum(Assinante owner, String tituloAlbum, String descricaoAlbum){
		Album album = new Album();
		album.setTitulo(tituloAlbum);
		album.setDescricao(descricaoAlbum);
		album.setNumeroAcessos(0L);
		
		owner.addAlbum(album);		
		getAlbumDAO().incluirAlbum(album);
	}
	
	public Foto incluirFoto(Long albumId, byte[] bytesArquivo, String nomeArquivo, Long tamanhoArquivo, String tipoArquivo, String legendaFoto){
		Foto foto = new Foto();
		foto.setNomeArquivo(nomeArquivo);
		foto.setTamanhoArquivo(tamanhoArquivo);
		foto.setTipoArquivo(tipoArquivo);
		foto.setLegenda(legendaFoto);			
		foto.setNumeroAcessos(0L);
		
		Album album = getAlbumDAO().buscarAlbum(albumId);
		album.addFoto(foto);
		
		getAlbumDAO().incluirFoto(foto);
		return foto;
	}
	
	public Album buscarAlbum(Long albumId){
		Album album = getAlbumDAO().buscarAlbum(albumId);
		return album;
	}
	
	public Foto buscarFoto(Long fotoId){
		Foto foto = getAlbumDAO().buscarFoto(fotoId);
		foto.setNumeroAcessos(foto.getNumeroAcessos() + 1);
		foto = getAlbumDAO().atualizarFoto(foto);
		return foto;
	}
	
	public void editarAlbum(Long albumId, String titulo, String descricao){
		Album album = getAlbumDAO().buscarAlbum(albumId);
		album.setTitulo(titulo);
		album.setDescricao(descricao);
		getAlbumDAO().atualizarAlbum(album);
	}
	
	public void excluirAlbum(Assinante assinante, Long albumId){
		Album album = this.buscarAlbum(albumId);
		assinante.removeAlbum(album);
		getAlbumDAO().excluirAlbum(album);		
	}
	
	public void excluirFoto(Long fotoId){
		Foto foto = getAlbumDAO().buscarFoto(fotoId);
		getAlbumDAO().excluirFoto(foto);
	}
	
	public void visualizarFoto(Foto foto){
		//foto.foiAcessada();
		//getAlbumDAO().atualizarAlb
	}
	
}
