package br.usp.ime.pictware.application.grupoacesso.service;

import br.usp.ime.pictware.business.grupoacesso.bo.GrupoAcesso;
import br.usp.ime.pictware.business.grupoacesso.bo.MembroGrupo;
import br.usp.ime.pictware.business.grupoacesso.dao.GrupoAcessoDAO;

public class ManterGrupoAcessoService {

	private GrupoAcessoDAO grupoAcessoDAO;
	
	private ManterGrupoAcessoService(){
		
	}
	
	public GrupoAcessoDAO getGrupoAcessoDAO() {
		return grupoAcessoDAO;
	}

	public void setGrupoAcessoDAO(GrupoAcessoDAO grupoAcessoDAO) {
		this.grupoAcessoDAO = grupoAcessoDAO;
	}

	public GrupoAcesso excluirMembro(Long grupoId, Long membroId) {
		GrupoAcesso grupoAcesso = getGrupoAcessoDAO().buscarGrupoAcesso(grupoId);
		MembroGrupo membro = getGrupoAcessoDAO().buscarMembro(membroId);
		grupoAcesso.removeMembro(membro);
		grupoAcesso = getGrupoAcessoDAO().atualizarGrupoAcesso(grupoAcesso);
		return grupoAcesso;		
	}

	public GrupoAcesso cadastrarMembro(Long grupoId, String emailMembro) {
		MembroGrupo membro = new MembroGrupo();
		membro.setEmail(emailMembro);
		GrupoAcesso grupoAcesso = getGrupoAcessoDAO().buscarGrupoAcesso(grupoId);
		grupoAcesso.addMembro(membro);
		grupoAcesso = getGrupoAcessoDAO().atualizarGrupoAcesso(grupoAcesso);
		return grupoAcesso;
	}
	
}
