package br.usp.ime.pictware.business.album.bo;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

import br.usp.ime.pictware.business.assinante.bo.Assinante;
import br.usp.ime.pictware.business.grupoacesso.bo.GrupoAcesso;

@Entity
public class Album {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Long id;
	
	@ManyToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="idOwner",nullable=false)
	private Assinante owner;
	
	private String titulo;
	private String descricao;
	private Long numeroAcessos;
	
	@OneToMany(cascade=CascadeType.ALL,mappedBy="album")
	private List<Foto> listaFotos;
	
	@ManyToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="idGrupoAcesso")
	private GrupoAcesso grupoAcesso;
	
	@OneToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="idCapa")
	private Foto capa;
	
	public Album(){
		listaFotos = new ArrayList<Foto>();
	}
		
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	
	public Assinante getOwner() {
		return owner;
	}

	public void setOwner(Assinante owner) {
		this.owner = owner;
	}

	public String getTitulo() {
		return titulo;
	}
	
	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}
	
	public String getDescricao() {
		return descricao;
	}
	
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	
	public Long getNumeroAcessos() {
		return numeroAcessos;
	}
	
	public void setNumeroAcessos(Long numeroAcessos) {
		this.numeroAcessos = numeroAcessos;
	}
	
	public List<Foto> getListaFotos() {
		return listaFotos;
	}
	
	public void setListaFotos(List<Foto> listaFotos) {
		this.listaFotos = listaFotos;
	}
	
	public GrupoAcesso getGrupoAcesso() {
		return grupoAcesso;
	}
	
	public void setGrupoAcesso(GrupoAcesso grupoAcesso) {
		this.grupoAcesso = grupoAcesso;
	}
	
	public Foto getCapa() {
		return capa;
	}
	
	public void setCapa(Foto capa) {
		this.capa = capa;
	}
	
	public void addFoto(Foto foto){
		listaFotos.add(foto);
		foto.setAlbum(this);
	}
	
	public boolean hasCapa(){
		return capa!=null;
	}
	
	public Foto getFoto(int index){
		return listaFotos.get(index);		
	}

	public void removeFoto(Foto foto) {
		listaFotos.remove(foto);
		foto.setAlbum(null);
	}
	
}