package br.usp.ime.pictware.business.album.bo;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

@Entity
public class Foto {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Long id;
	
	private String legenda;
	
	private Long numeroAcessos;
	
	@Embedded
	private DetalheFoto detalheFoto;
	
	@ManyToOne(fetch=FetchType.LAZY)
	@JoinColumn(name="idAlbum",nullable=false)
	private Album album;

	@OneToMany(cascade=CascadeType.ALL)
	@JoinTable(name="ComentariosDoAlbum")
	private List<Comentario> listaComentarios;
		
	public Foto(){
		listaComentarios = new ArrayList<Comentario>();
		detalheFoto = new DetalheFoto();
	}
	
	public List<Comentario> getListaComentarios() {
		return listaComentarios;
	}

	public void setListaComentarios(List<Comentario> listaComentarios) {
		this.listaComentarios = listaComentarios;
	}

	public Long getId(){
		return id;
	}
	
	public void setId(Long id){
		this.id = id;
	}

	public String getLegenda() {
		return legenda;
	}

	public void setLegenda(String legenda) {
		this.legenda = legenda;
	}

	public Long getNumeroAcessos() {
		return numeroAcessos;
	}

	public void setNumeroAcessos(Long numeroAcessos) {
		this.numeroAcessos = numeroAcessos;
	}
	
	public String getNomeArquivo() {
		return detalheFoto.getNomeArquivo();
	}
	
	public void setNomeArquivo(String nomeArquivo) {
		detalheFoto.setNomeArquivo(nomeArquivo);
	}
	
	public Long getTamanhoArquivo() {
		return detalheFoto.getTamanhoArquivo();
	}
	
	public void setTamanhoArquivo(Long tamanhoArquivo) {
		detalheFoto.setTamanhoArquivo(tamanhoArquivo);
	}
	
	public String getTipoArquivo() {
		return detalheFoto.getTipoArquivo();
	}

	public void setTipoArquivo(String tipoArquivo) {
		this.detalheFoto.setTipoArquivo(tipoArquivo);
	}
	
	public void foiAcessada(){
		this.numeroAcessos += 1L;
	}
	
	public DetalheFoto getDetalheFoto(){
		return detalheFoto;
	}

	public Album getAlbum() {
		return album;
	}

	public void setAlbum(Album album) {
		this.album = album;
	}

	
}
