package br.usp.ime.pictware.business.assinante.bo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.PrimaryKeyJoinColumn;

import br.usp.ime.pictware.business.album.bo.Album;
import br.usp.ime.pictware.business.grupoacesso.bo.GrupoAcesso;

@Entity
@PrimaryKeyJoinColumn(name="idPessoa")
public class Assinante extends Pessoa implements Serializable{

	private static final long serialVersionUID = -5706033011774626390L;

	private String login;
	private String senha;

	@OneToMany(cascade=CascadeType.ALL)
	@JoinTable(name="GruposAcessoDoAssinante",joinColumns = @JoinColumn(name="assinante_id"),inverseJoinColumns = @JoinColumn(name="grupo_id"))
	private List<GrupoAcesso> listaGrupoAcesso;
	
	@OneToMany(cascade=CascadeType.ALL,mappedBy="owner")
	private List<Album> listaAlbuns;
	
	public Assinante(){
		listaAlbuns = new ArrayList<Album>();
		listaGrupoAcesso = new ArrayList<GrupoAcesso>();
	}
	
	public String getSenha() {
		return senha;
	}

	public void setSenha(String senha) {
		this.senha = senha;
	}
	
	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}
	
	public List<GrupoAcesso> getListaGrupoAcesso() {
		return listaGrupoAcesso;
	}

	public void setListaGrupoAcesso(List<GrupoAcesso> listaGrupoAcesso) {
		this.listaGrupoAcesso = listaGrupoAcesso;
	}

	public GrupoAcesso getGrupoAcesso(int index){
		return listaGrupoAcesso.get(index);		
	}
	
	public List<Album> getListaAlbuns() {
		return listaAlbuns;
	}

	public void setListaAlbuns(List<Album> listaAlbuns) {
		this.listaAlbuns = listaAlbuns;
	}
	
	public Album getAlbum(int index){
		return listaAlbuns.get(index);		
	}

	public void addGrupoAcesso(GrupoAcesso grupoAcesso){
		this.listaGrupoAcesso.add(grupoAcesso);
	}
	
	public void addAlbum(Album album){
		album.setOwner(this);
		this.listaAlbuns.add(album);
	}
	
	public void removeAlbum(Album album){
		this.listaAlbuns.remove(album);
		album.setOwner(null);
	}
	
}
