package br.usp.ime.pictware.business.grupoacesso.bo;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;

@Entity
public class GrupoAcesso {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Long id;
	private String nome;
	
	@OneToMany(cascade=CascadeType.ALL)
	@JoinTable(name="MembrosDoGrupo")
	private List<MembroGrupo> listaMembros;
	
	public GrupoAcesso(){
		listaMembros = new ArrayList<MembroGrupo>();
	}
	
	public List<MembroGrupo> getListaMembros() {
		return listaMembros;
	}

	public void setListaMembros(List<MembroGrupo> listaMembros) {
		this.listaMembros = listaMembros;
	}

	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	
	public void addMembro(MembroGrupo membroGrupo){
		listaMembros.add(membroGrupo);
	}
	
	public void removeMembro(MembroGrupo membroGrupo){
		listaMembros.remove(membroGrupo);
	}
	
}
