package br.usp.ime.pictware.infraestrutura.persistencia.util;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.DataSource;

public class ConnectionManager {

	private DataSource dataSource;
	
	private static ConnectionManager instance = new ConnectionManager();
	
	private ConnectionManager(){}
	
	public static ConnectionManager getInstance(){
		return instance;
	}
	
	public void setDataSource(DataSource dataSource){
		this.dataSource = dataSource;
	}
	
	public Connection openConnection(){
		try{
			return dataSource.getConnection();		
		}catch(SQLException e){
			return null;
		}
	}
	
	public void closeConnection(Connection conn){
		try{
			if (conn != null && !conn.isClosed()){
				conn.close();
			}
		}catch(SQLException e){
			e.printStackTrace();
			System.out.println("No foi possvel fechar conexo");
		}
	}
}
