package br.usp.ime.pictware.web.action.manteralbum;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

import com.aetrion.flickr.Flickr;
import com.aetrion.flickr.FlickrException;
import com.aetrion.flickr.REST;
import com.aetrion.flickr.photos.Photo;
import com.aetrion.flickr.photos.PhotoList;
import com.aetrion.flickr.photos.PhotosInterface;
import com.aetrion.flickr.photos.SearchParameters;

import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;
import br.usp.ime.pictware.web.mashup.FlickrHelper;
import br.usp.ime.pictware.web.mashup.FotoBean;
import br.usp.ime.pictware.web.mashup.PicasaHelper;

public class BuscarFotoAction implements Action{

	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		String query = request.getParameter("query");
		int numFotos = 10;
		
		FlickrHelper flickrHelper = new FlickrHelper();
		List<FotoBean> listaFotosFlickr = flickrHelper.buscarFotos(query,10);
		
		PicasaHelper picasaHelper = new PicasaHelper();
		List<FotoBean> listaFotosPicasa = picasaHelper.buscarFotos(query,10);
		
		//Insere as fotos das duas fontes em uma nica coleo
		//numa ordem inteligente
		List<FotoBean> listaFotos = new ArrayList<FotoBean>();
		for (int i=0; i<numFotos; i++){
			if (i<listaFotosFlickr.size()){
				listaFotos.add(listaFotosFlickr.get(i));	
			}
			if (i<listaFotosPicasa.size()){
				listaFotos.add(listaFotosPicasa.get(i));	
			}			
		}
		
		request.setAttribute("listaFotos", listaFotos);
		request.setAttribute("pageOffset", new Integer(1));
		
		
		return actionMapping.findForward("explorar-fotos-externas");		
	}

}
