package br.usp.ime.pictware.web.action.manteralbum;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import br.usp.ime.pictware.application.album.service.ManterAlbumService;
import br.usp.ime.pictware.application.assinante.service.ManterAssinanteService;
import br.usp.ime.pictware.business.assinante.bo.Assinante;
import br.usp.ime.pictware.infraestrutura.persistencia.assinante.FiltroBuscaAssinante;
import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;

public class ExcluirAlbumAction implements Action{

	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		WebApplicationContext ctx = WebApplicationContextUtils.getRequiredWebApplicationContext(request.getSession().getServletContext());
		ManterAlbumService manterAlbumService = (ManterAlbumService)ctx.getBean("albumService");
		ManterAssinanteService manterAssinanteService = (ManterAssinanteService)ctx.getBean("assinanteService");
		
		Long uid = (Long)request.getSession().getAttribute("uid");		
		FiltroBuscaAssinante filtroBusca = new FiltroBuscaAssinante();
		filtroBusca.setUid(uid);	
		Assinante assinante = manterAssinanteService.buscarAssinante(filtroBusca);
		
		Long albumId = Long.parseLong(request.getParameter("albumId"));		
		manterAlbumService.excluirAlbum(assinante, albumId);
		
		request.setAttribute("listaAlbuns", assinante.getListaAlbuns());		
		
		return actionMapping.findForward("album-excluido");
	}
	
}
