package br.usp.ime.pictware.web.action.manterassinante;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import br.usp.ime.pictware.application.assinante.service.ManterAssinanteService;
import br.usp.ime.pictware.business.assinante.bo.Assinante;
import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;

public class InserirAssinanteAction implements Action{

	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		WebApplicationContext ctx = WebApplicationContextUtils.getRequiredWebApplicationContext(request.getSession().getServletContext());
		ManterAssinanteService manterAssinanteService = (ManterAssinanteService)ctx.getBean("assinanteService");
	
		String login = request.getParameter("login");
		
		String senha = request.getParameter("senha");
		String confirmacaoSenha = request.getParameter("senhaConfirmada");
		
		//Confirmao da senha
		if (!confirmacaoSenha.equals(senha)){
			//TODO: devolver erro
			return actionMapping.findForward("senha-errada");
		}
		
		String nomeAssinante = request.getParameter("nome");
		String apelido = request.getParameter("apelido");
					
		Assinante assinante = manterAssinanteService.cadastrarAssinante(login, senha, nomeAssinante, apelido);
		
		if (assinante != null){
			//Coloca o userId e o apelido na sesso
			request.getSession().setAttribute("uid", assinante.getId());
			request.getSession().setAttribute("apelido", assinante.getApelido());
			return actionMapping.findForward("usuario-cadastrado");
		}
		else{
			return actionMapping.findForward("usuario-duplicado");
		}				
	}

}
