package br.usp.ime.pictware.web.action.manterassinante;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import br.usp.ime.pictware.application.assinante.service.ManterAssinanteService;
import br.usp.ime.pictware.business.assinante.bo.Assinante;
import br.usp.ime.pictware.infraestrutura.persistencia.assinante.FiltroBuscaAssinante;
import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;

public class LoginAction implements Action{

	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		WebApplicationContext ctx = WebApplicationContextUtils.getRequiredWebApplicationContext(request.getSession().getServletContext());
		ManterAssinanteService manterAssinanteService = (ManterAssinanteService)ctx.getBean("assinanteService");
		
		String login = request.getParameter("login");
		String senha = request.getParameter("senha");
		
		FiltroBuscaAssinante filtroBusca = new FiltroBuscaAssinante();
		filtroBusca.setLogin(login);
		filtroBusca.setSenha(senha);
		
		Assinante assinante = manterAssinanteService.buscarAssinante(filtroBusca);
				
		if (assinante != null){
			
			//Coloca o userId e o apelido na sesso
			request.getSession().setAttribute("uid", assinante.getId());
			request.getSession().setAttribute("apelido", assinante.getApelido());
			
			//Coloca a lista de albuns na request
			request.setAttribute("listaAlbuns", assinante.getListaAlbuns());
				
			return actionMapping.findForward("autenticado");
		}
		else{
			request.getSession().invalidate();
			request.setAttribute("erroSenha", "E-mail ou senha incorretos. Confira seu e-mail e senha e tente novamente.");
			return actionMapping.findForward("nao-autenticado");
		}
		
	}

}
