package br.usp.ime.pictware.web.action.mantergrupoacesso;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import br.usp.ime.pictware.application.grupoacesso.service.ManterGrupoAcessoService;
import br.usp.ime.pictware.business.grupoacesso.bo.GrupoAcesso;
import br.usp.ime.pictware.web.framework.action.Action;
import br.usp.ime.pictware.web.framework.action.ActionForward;
import br.usp.ime.pictware.web.framework.action.ActionMapping;

public class InserirMembroGrupoAction implements Action{

	public ActionForward execute(ActionMapping actionMapping,
			HttpServletRequest request, HttpServletResponse response) {
		
		WebApplicationContext ctx = WebApplicationContextUtils.getRequiredWebApplicationContext(request.getSession().getServletContext());
		ManterGrupoAcessoService manterGrupoAcessoService = (ManterGrupoAcessoService)ctx.getBean("grupoAcessoService");

		Long grupoId = Long.parseLong(request.getParameter("grupoId"));	
		String emailMembro = request.getParameter("email");
		
		GrupoAcesso grupoAcesso = manterGrupoAcessoService.cadastrarMembro(grupoId, emailMembro);
		request.setAttribute("grupoAcesso", grupoAcesso);
		
		return actionMapping.findForward("membro-inserido");
	}

}
