package br.usp.ime.pictware.web.listener;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.sql.DataSource;

import br.usp.ime.pictware.infraestrutura.persistencia.util.ConnectionManager;

/**
 * Application Lifecycle Listener implementation class DataSourceListener
 *
 */
public class DataSourceListener implements ServletContextListener {

    /**
     * Default constructor. 
     */
    public DataSourceListener() {
        // TODO Auto-generated constructor stub
    }

	/**
     * @see ServletContextListener#contextInitialized(ServletContextEvent)
     */
    public void contextInitialized(ServletContextEvent servletContextEvent) {
    	try{
	    	//Obtem o naming context
	    	Context envCtx = (Context) new InitialContext().lookup("java:comp/env");
	    	//Look up data source
			DataSource dataSource = (DataSource) envCtx.lookup("jdbc/PICTWAREDB");
			ConnectionManager.getInstance().setDataSource(dataSource);
			
			System.out.println("DataSource looked up!");
    	}catch(NamingException e){
    		//TODO:LOG
		}
    }

	/**
     * @see ServletContextListener#contextDestroyed(ServletContextEvent)
     */
    public void contextDestroyed(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
    }
	
}
