package br.usp.ime.pictware.web.mashup;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang.StringUtils;

import sqlj.runtime.profile.util.CustomizerPropertyInfo;

import com.ctc.wstx.util.StringUtil;
import com.google.gdata.client.*;
import com.google.gdata.client.Query.CustomParameter;
import com.google.gdata.client.photos.*;
import com.google.gdata.data.*;
import com.google.gdata.data.media.*;
import com.google.gdata.data.photos.*;
import com.google.gdata.client.photos.PicasawebService;

public class PicasaHelper {

	private List<FotoBean> listaFotos = new ArrayList<FotoBean>(10);
	
	public PicasaHelper(){
		
	}
	
	public List<FotoBean> buscarFotos(String query, int numFotos) {
		
		try{	
			PicasawebService picasaWebService = new PicasawebService("ImeUSP-PictWare-v0.5");
			
			URL baseSearchUrl = new URL("http://picasaweb.google.com/data/feed/api/all");
			
			Query myQuery = new Query(baseSearchUrl);
			myQuery.setStringCustomParameter("kind", "photo");
			myQuery.setIntegerCustomParameter("thumbsize", 200);
			myQuery.setFullTextQuery(query);
			myQuery.setMaxResults(numFotos);
			
	
			AlbumFeed searchResultsFeed = picasaWebService.query(myQuery, AlbumFeed.class);
	
			for (PhotoEntry photo : searchResultsFeed.getPhotoEntries()) {				
			    FotoBean fotoBean = new FotoBean();
			    fotoBean.setLinkFotoTamanhoNormal(photo.getHtmlLink().getHref());
			    fotoBean.setLinkFotoThumbnail(photo.getMediaThumbnails().get(0).getUrl());
			    fotoBean.setLinkOwnerFoto(photo.getAuthors().get(0).getUri());
			    fotoBean.setResolucao(photo.getWidth() + "x" + photo.getHeight());
			    fotoBean.setTamanho(String.valueOf(photo.getSize()));
			    //fotoBean.setTipoArquivo(photo.g
			    fotoBean.setTitulo(StringUtils.abbreviate(photo.getDescription().getPlainText(),20));
			    listaFotos.add(fotoBean);
			}
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		return listaFotos;
	}

}
